import {mergeProps as $fXQi9$mergeProps, filterDOMProps as $fXQi9$filterDOMProps, chain as $fXQi9$chain} from "@react-aria/utils";
import {useFocusable as $fXQi9$useFocusable} from "@react-aria/focus";
import {usePress as $fXQi9$usePress} from "@react-aria/interactions";

function $parcel$export(e, n, v, s) {
  Object.defineProperty(e, n, {get: v, set: s, enumerable: true, configurable: true});
}
var $406353e93a1b90e2$exports = {};

$parcel$export($406353e93a1b90e2$exports, "useButton", () => $406353e93a1b90e2$export$ea18c227d4417cc3);




function $406353e93a1b90e2$export$ea18c227d4417cc3(props, ref) {
    let { elementType: elementType = 'button' , isDisabled: isDisabled , onPress: onPress , onPressStart: onPressStart , onPressEnd: onPressEnd , onPressChange: onPressChange , preventFocusOnPress: // @ts-ignore - undocumented
    preventFocusOnPress , allowFocusWhenDisabled: // @ts-ignore - undocumented
    allowFocusWhenDisabled , // @ts-ignore
    onClick: deprecatedOnClick , href: href , target: target , rel: rel , type: type = 'button'  } = props;
    let additionalProps;
    if (elementType === 'button') additionalProps = {
        type: type,
        disabled: isDisabled
    };
    else additionalProps = {
        role: 'button',
        tabIndex: isDisabled ? undefined : 0,
        href: elementType === 'a' && isDisabled ? undefined : href,
        target: elementType === 'a' ? target : undefined,
        type: elementType === 'input' ? type : undefined,
        disabled: elementType === 'input' ? isDisabled : undefined,
        'aria-disabled': !isDisabled || elementType === 'input' ? undefined : isDisabled,
        rel: elementType === 'a' ? rel : undefined
    };
    let { pressProps: pressProps , isPressed: isPressed  } = $fXQi9$usePress({
        onPressStart: onPressStart,
        onPressEnd: onPressEnd,
        onPressChange: onPressChange,
        onPress: onPress,
        isDisabled: isDisabled,
        preventFocusOnPress: preventFocusOnPress,
        ref: ref
    });
    let { focusableProps: focusableProps  } = $fXQi9$useFocusable(props, ref);
    if (allowFocusWhenDisabled) focusableProps.tabIndex = isDisabled ? -1 : focusableProps.tabIndex;
    let buttonProps = $fXQi9$mergeProps(focusableProps, pressProps, $fXQi9$filterDOMProps(props, {
        labelable: true
    }));
    return {
        isPressed: isPressed,
        buttonProps: $fXQi9$mergeProps(additionalProps, buttonProps, {
            'aria-haspopup': props['aria-haspopup'],
            'aria-expanded': props['aria-expanded'],
            'aria-controls': props['aria-controls'],
            'aria-pressed': props['aria-pressed'],
            onClick: (e)=>{
                if (deprecatedOnClick) {
                    deprecatedOnClick(e);
                    console.warn('onClick is deprecated, please use onPress');
                }
            }
        })
    };
}


var $02948abd23f2e84a$exports = {};

$parcel$export($02948abd23f2e84a$exports, "useToggleButton", () => $02948abd23f2e84a$export$51e84d46ca0bc451);



function $02948abd23f2e84a$export$51e84d46ca0bc451(props, state, ref) {
    const { isSelected: isSelected  } = state;
    const { isPressed: isPressed , buttonProps: buttonProps  } = $406353e93a1b90e2$export$ea18c227d4417cc3({
        ...props,
        onPress: $fXQi9$chain(state.toggle, props.onPress)
    }, ref);
    return {
        isPressed: isPressed,
        buttonProps: $fXQi9$mergeProps(buttonProps, {
            'aria-pressed': isSelected
        })
    };
}




export {$406353e93a1b90e2$export$ea18c227d4417cc3 as useButton, $02948abd23f2e84a$export$51e84d46ca0bc451 as useToggleButton};
//# sourceMappingURL=module.js.map
